/*-- Document Ready Starts --*/
$(document).ready(function () {
    // Declear local variable
    var score = 0;
    var livesctr = 0;
    var myInterval;
    var optionlnght = 0;
    var questionObj;
    var fillblank = 0;
	var AutoSolved=false;

    var questionAudio;
    var optionAudio;
    optionAudio = document.createElement("audio");
    var timerval = game_ui["game_screen"]["settimer"].timeval;
    var bgmsrc = game_ui["game_screen"].backgroundMusic;
    var curQCtr = 0;
    var playmusicflag = true;
    // add events
    resizeHandler();

    $("#ins_next").bind("click", nextscreen);
    $("#replaybtn").bind("click", replay);
    $("#reset").bind("click", replay);
    $("#start").bind("click", startgame);
    $("#closebtn").bind("click", playgame);
    update_ui_Settings();

    // update UI as per settins js parameters function
    function update_ui_Settings() {

        //  update UI for instruction backgrounds like backgroundImage or backgroundColor
        const instructiongameElm = document.getElementById('instructionpage');
        if (game_ui["instruction_screen"].backgroundImage == "none") {
            instructiongameElm.style.backgroundColor = game_ui["instruction_screen"].backgroundColor;
        } else {
            instructiongameElm.style.backgroundImage = 'url(' + game_ui["instruction_screen"].backgroundImage + ')';
        }

        //  update UI for instruction title text
        const instructionTextElm = document.getElementById('instruction_title');
        instructionTextElm.textContent = game_ui["instruction_screen"]["titleUI"].titleText;
        instructionTextElm.style.fontSize = game_ui["instruction_screen"]["titleUI"].fontSize;
        instructionTextElm.style.color = game_ui["instruction_screen"]["titleUI"].color;
        instructionTextElm.style.top = game_ui["instruction_screen"]["titleUI"].top;
        instructionTextElm.style.animation = game_ui["instruction_screen"]["titleUI"].animation;
        instructionTextElm.style.width = game_ui["instruction_screen"]["titleUI"].width;
        instructionTextElm.style.textAlign = game_ui["instruction_screen"]["titleUI"].textAlign;

        //  update UI for instruction age group text
        const agegrpTextElm = document.getElementById('agegrp');
        agegrpTextElm.textContent = game_ui["instruction_screen"]["agegrp"].titleText
        agegrpTextElm.style.fontSize = game_ui["instruction_screen"]["agegrp"].fontSize;
        agegrpTextElm.style.color = game_ui["instruction_screen"]["agegrp"].color;
        agegrpTextElm.style.top = game_ui["instruction_screen"]["agegrp"].top;
        agegrpTextElm.style.animation = game_ui["instruction_screen"]["agegrp"].animation;
        agegrpTextElm.style.width = game_ui["instruction_screen"]["agegrp"].width;
        agegrpTextElm.style.textAlign = game_ui["instruction_screen"]["agegrp"].textAlign;
        agegrpTextElm.style.right = game_ui["instruction_screen"]["agegrp"].right;

        //  update UI for instruction description text
        const descriptionTextElm = document.getElementById('description_text');
        descriptionTextElm.textContent = game_ui["instruction_screen"]["descriptionUI"].titleText;
        descriptionTextElm.style.width = game_ui["instruction_screen"]["descriptionUI"].width;
        descriptionTextElm.style.fontSize = game_ui["instruction_screen"]["descriptionUI"].fontSize;
        descriptionTextElm.style.color = game_ui["instruction_screen"]["descriptionUI"].color;
        descriptionTextElm.style.textAlign = game_ui["instruction_screen"]["descriptionUI"].textAlign;
        descriptionTextElm.style.top = game_ui["instruction_screen"]["descriptionUI"].top;
        descriptionTextElm.style.animation = game_ui["instruction_screen"]["descriptionUI"].animation;

        //  update UI for instruction objective text
        const objTextElm = document.getElementById('objectives_text');
        objTextElm.textContent = game_ui["instruction_screen"]["objUI"].titleText;
        objTextElm.style.fontSize = game_ui["instruction_screen"]["objUI"].fontSize;
        objTextElm.style.color = game_ui["instruction_screen"]["objUI"].color;
        objTextElm.style.width = game_ui["instruction_screen"]["objUI"].width;
        objTextElm.style.top = game_ui["instruction_screen"]["objUI"].top;
        objTextElm.style.animation = game_ui["instruction_screen"]["objUI"].animation;
        if (game_ui["language"].type == "RTL") {
            objTextElm.style.right = game_ui["instruction_screen"]["objUI"].leftRight;
            document.querySelector("#objectives_text").classList.add("RTL");
        }else{
            objTextElm.style.left = game_ui["instruction_screen"]["objUI"].leftRight;
            document.querySelector("#objectives_text").classList.add("LTR");
        }

        //  update UI for instruction objectives list text
        const objlistTextElm = document.getElementById('objectives_list');
        objlistTextElm.innerHTML = game_ui["instruction_screen"]["objelms"];
        objlistTextElm.style.fontSize = game_ui["instruction_screen"]["objelmsUI"].fontSize;
        objlistTextElm.style.color = game_ui["instruction_screen"]["objelmsUI"].color;
        objlistTextElm.style.width = game_ui["instruction_screen"]["objelmsUI"].width;
        objlistTextElm.style.top = game_ui["instruction_screen"]["objelmsUI"].top;
        objlistTextElm.style.animation = game_ui["instruction_screen"]["objelmsUI"].animation;
        if (game_ui["language"].type == "RTL") {
            objlistTextElm.style.right = game_ui["instruction_screen"]["objelmsUI"].leftRight;
            document.querySelector("#objectives_list").classList.add("RTL");
        }else{
            objlistTextElm.style.left = game_ui["instruction_screen"]["objelmsUI"].leftRight;
            document.querySelector("#objectives_list").classList.add("LTR");
        }
        


        //  update UI for ins button
        const insbtnElm = document.getElementById('ins_next');
        insbtnElm.style.backgroundImage = 'url(' + game_ui["instruction_screen"]["nextinsbtnUI"].backgroundImage + ')';
        insbtnElm.style.width = game_ui["instruction_screen"]["nextinsbtnUI"].width;
        insbtnElm.style.height = game_ui["instruction_screen"]["nextinsbtnUI"].height;
        
        insbtnElm.style.top = game_ui["instruction_screen"]["nextinsbtnUI"].top;
        insbtnElm.style.animation = game_ui["instruction_screen"]["nextinsbtnUI"].animation;

        if (game_ui["language"].type == "RTL") {
            insbtnElm.style.left = game_ui["instruction_screen"]["nextinsbtnUI"].leftRight;
            document.querySelector("#objectives_list").classList.add("RTL");
        }else{
            insbtnElm.style.right = game_ui["instruction_screen"]["nextinsbtnUI"].leftRight;
            document.querySelector("#objectives_list").classList.add("LTR");
        }



        //  update UI for start backgrounds like backgroundImage or backgroundColor
        const startgameElm = document.getElementById('startgame');
        if (game_ui["start_screen"].backgroundImage == "none") {
            startgameElm.style.backgroundColor = game_ui["start_screen"].backgroundColor;
        } else {
            startgameElm.style.backgroundImage = 'url(' + game_ui["start_screen"].backgroundImage + ')';
        }

        //  update UI for start title text
        const startTextElm = document.getElementById('start_text');
        startTextElm.textContent = game_ui["start_screen"]["titleUI"].titleText
        startTextElm.style.fontSize = game_ui["start_screen"]["titleUI"].fontSize;
        startTextElm.style.color = game_ui["start_screen"]["titleUI"].color;
        startTextElm.style.width = game_ui["start_screen"]["titleUI"].width;
        startTextElm.style.textAlign = game_ui["start_screen"]["titleUI"].textAlign;
        startTextElm.style.top = game_ui["start_screen"]["titleUI"].top;
        startTextElm.style.animation = game_ui["start_screen"]["titleUI"].animation;

        //  update UI for start instructions text
        const insTextElm = document.getElementById('ins_text');
        insTextElm.textContent = game_ui["start_screen"]["instructionUI"].titleText
        insTextElm.style.fontSize = game_ui["start_screen"]["instructionUI"].fontSize;
        insTextElm.style.color = game_ui["start_screen"]["instructionUI"].color;
        insTextElm.style.width = game_ui["start_screen"]["instructionUI"].width;
        insTextElm.style.textAlign = game_ui["start_screen"]["instructionUI"].textAlign;
        insTextElm.style.top = game_ui["start_screen"]["instructionUI"].top;
        insTextElm.style.animation = game_ui["start_screen"]["instructionUI"].animation;

        //  update UI for start button
        const startbtnElm = document.getElementById('start');
        startbtnElm.style.backgroundImage = 'url(' + game_ui["start_screen"]["startButtonUI"].backgroundImage + ')';
        startbtnElm.style.width = game_ui["start_screen"]["startButtonUI"].width;
        startbtnElm.style.height = game_ui["start_screen"]["startButtonUI"].height;
        startbtnElm.style.left = game_ui["start_screen"]["startButtonUI"].left;
        startbtnElm.style.top = game_ui["start_screen"]["startButtonUI"].top;

        //  update UI for main game backgrounds like backgroundImage or backgroundColor
        const maingameElm = document.getElementById('game_container');
        if (game_ui["game_screen"].backgroundImage == "none") {
            maingameElm.style.backgroundColor = game_ui["game_screen"].backgroundColor;
        } else {
            maingameElm.style.backgroundImage = 'url(' + game_ui["game_screen"].backgroundImage + ')';
        }

        //  update UI for timerbox
        const timerboxElm = document.getElementById('timerbox');
        timerboxElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["timerboxUI"].backgroundImage + ')';
        timerboxElm.style.width = game_ui["game_screen"]["timerboxUI"].width;
        timerboxElm.style.height = game_ui["game_screen"]["timerboxUI"].height;
        timerboxElm.style.left = game_ui["game_screen"]["timerboxUI"].left;
        timerboxElm.style.top = game_ui["game_screen"]["timerboxUI"].top;

        //  update UI for innertimerUI
        const timerElm = document.getElementById('timer');
        timerElm.style.left = game_ui["game_screen"]["timerUI"].left;
        timerElm.style.top = game_ui["game_screen"]["timerUI"].top;
        timerElm.style.fontSize = game_ui["game_screen"]["timerUI"].fontSize;
        timerElm.style.color = game_ui["game_screen"]["timerUI"].color;
        timerElm.style.fontWeight = game_ui["game_screen"]["timerUI"].fontWeight;
        timerElm.style.color = game_ui["game_screen"]["timerUI"].color;

        //  update UI for play sound UI
        const playaudioElm = document.getElementById('play_audio');
        playaudioElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["playsoundUI"].backgroundImage + ')';
        playaudioElm.style.width = game_ui["game_screen"]["playsoundUI"].width;
        playaudioElm.style.height = game_ui["game_screen"]["playsoundUI"].height;
        playaudioElm.style.right = game_ui["game_screen"]["playsoundUI"].right;
        playaudioElm.style.bottom = game_ui["game_screen"]["playsoundUI"].bottom;
        playaudioElm.style.borderRadius = game_ui["game_screen"]["playsoundUI"].borderRadius;
        playaudioElm.style.padding = game_ui["game_screen"]["playsoundUI"].padding;

        //  update UI for pause sound UI
        const pauseaudioElm = document.getElementById('pause_audio');
        pauseaudioElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["pausesoundUI"].backgroundImage + ')';
        pauseaudioElm.style.width = game_ui["game_screen"]["pausesoundUI"].width;
        pauseaudioElm.style.height = game_ui["game_screen"]["pausesoundUI"].height;
        pauseaudioElm.style.right = game_ui["game_screen"]["pausesoundUI"].right;
        pauseaudioElm.style.bottom = game_ui["game_screen"]["pausesoundUI"].bottom;
        pauseaudioElm.style.borderRadius = game_ui["game_screen"]["pausesoundUI"].borderRadius;
        pauseaudioElm.style.padding = game_ui["game_screen"]["pausesoundUI"].padding;

        //  update UI for tryfeedback UI
        const tryfeedbackElm = document.getElementById('tryfeedback');
        tryfeedbackElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["tryagainUI"].backgroundImage + ')';
        tryfeedbackElm.style.width = game_ui["game_screen"]["tryagainUI"].width;
        tryfeedbackElm.style.height = game_ui["game_screen"]["tryagainUI"].height;
        tryfeedbackElm.style.left = game_ui["game_screen"]["tryagainUI"].left;
        tryfeedbackElm.style.top = game_ui["game_screen"]["tryagainUI"].top;
        tryfeedbackElm.style.borderRadius = game_ui["game_screen"]["tryagainUI"].borderRadius;

        //  update UI for correctfeedback UI
        const correctfeedbackElm = document.getElementById('correctfeedback');
        correctfeedbackElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["correctfeedbackUI"].backgroundImage + ')';
        correctfeedbackElm.style.width = game_ui["game_screen"]["correctfeedbackUI"].width;
        correctfeedbackElm.style.height = game_ui["game_screen"]["correctfeedbackUI"].height;
        correctfeedbackElm.style.left = game_ui["game_screen"]["correctfeedbackUI"].left;
        correctfeedbackElm.style.top = game_ui["game_screen"]["correctfeedbackUI"].top;
        correctfeedbackElm.style.borderRadius = game_ui["game_screen"]["correctfeedbackUI"].borderRadius;


        //  update intro vedio
        $("#myVideo source").attr("src", game_ui["intro_vedio"].src);
        $("#myVideo")[0].load();

        //  update timer count as per settings
        if (game_ui["game_screen"]["settimer"].count == "none") {
            $("#timerbox").hide();
        }

        //  update random questions as per settings
        if (game_ui["game_screen"]["randomQuestions"].randomval == true) {
            shuffleArray(gamedata["Questions"]);
        }

        //  update liives as per settings
        if (game_ui["game_screen"]["lives"].number >= 1 && game_ui["game_screen"]["lives"].enable == true) {
            for (var i = 0; i < game_ui["game_screen"]["lives"].number; i++) {
                $("<div/>", {
                    'id': 'lives' + i,
                    'class': 'lives'
                }).appendTo('#livesbox');
            }
        }

        // Review link
        $("#reviewbtn").bind("click", function () {
            var url = game_ui["game_screen"]["reviewlink"].link; // Specify the URL of the link to be opened
            window.open(url, '_blank');
        });

    }

    // ins nextscreen function
    function nextscreen() {
        $("#instructionpage").hide();
        if (game_ui["intro_vedio"].display == true) {
            $("#vediocontainer").show();
            $("#myVideo")[0].play();
        } else {
            $("#startgame").show();
        }

    }

    // start game function
    function startgame() {
        playclick();
        $("#startgame").hide();
        $("#options_container").show();
        playbgm();
        addTimer();
        addElements();
    }

    // play game function
    function playgame() {
        $("#startgame").show();
        $("#vediocontainer").hide();
        $("#myVideo")[0].pause();
    }

    // shuffle Array function
    function shuffleArray(array) {
        for (var i = array.length - 1; i > 0; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            var temp = array[i];
            array[i] = array[j];
            array[j] = temp;
        }
    }

    // add timer function 
    function addTimer() {

        if (game_ui["game_screen"]["settimer"].count == "down") {
            myInterval = setInterval(function () {
                timerval--;
                if (timerval == 0) {
                    clearInterval(myInterval);
                    $("#timeupbg").show();
                    $(".timeup").removeClass('animated zoomIn');
                    $(".timeup").addClass('animated zoomIn');
                    playtryagain();
                }
                var minutes = Math.floor(timerval / 60);
                var seconds = timerval % 60;
                var formattedTime = ("0" + minutes).slice(-2) + ":" + ("0" + seconds).slice(-2);
                $("#timer").text(formattedTime);
            }, 1000);
        }

        if (game_ui["game_screen"]["settimer"].count == "up") {

            timerval = 0;
            myInterval = setInterval(function () {
                timerval++;
                if (timerval == game_ui["game_screen"]["settimer"].timeval) {
                    clearInterval(myInterval);
                    $("#timeupbg").show();
                    $(".timeup").removeClass('animated zoomIn');
                    $(".timeup").addClass('animated zoomIn');
                    playtryagain();
                }
                var minutes = Math.floor(timerval / 60);
                var seconds = timerval % 60;
                var formattedTime = ("0" + minutes).slice(-2) + ":" + ("0" + seconds).slice(-2);
                $("#timer").text(formattedTime);
            }, 1000);
        }

        if (game_ui["game_screen"]["settimer"].count == "none") {
            $("#timerbox").hide();
        }

    }

    // add game elements function
    function addElements() {
		AutoSolved=false;
        if (game_ui["game_screen"]["layout"].type == 1) {
            var dragclass = "drag_items_1";
            var dropclass = "drop_items_1";
            var cls_drag = "ClsDrag_1";
        } else {
            var dragclass = "drag_items_2";
            var dropclass = "drop_items_2";
            var cls_drag = "ClsDrag_2";
        }

        $("<div/>", {
            'id': "drag_items",
            'class': dragclass
        }).appendTo('#options_container');
        $("<div/>", {
            'id': "drop_items",
            'class': dropclass
        }).appendTo('#options_container');

        if (game_ui["language"].type == "RTL") {
            $("#drop_items").addClass("RTL");
            $("#drag_items").addClass("RTL");
        } else {
            $("#drop_items").addClass("LTR");
            $("#drag_items").addClass("LTR");
        }
		
		//submit answers button
        $("<div/>", {
            'id': "submitbtn"
        }).appendTo('#options_container');
        $("<p/>", {
            'id': "submit_text",
            'class': "submit_text",
            'html': ""
        }).appendTo('#submitbtn');
        $("#submitbtn").bind("click", checkresult);
		
		//solve button
		$("<div/>", {
            'id': "solvebtn"
        }).appendTo('#options_container');
        $("<p/>", {
            'id': "submit_text",
            'class': "solve_text",
            'html': "الحل"
        }).appendTo('#solvebtn');
        $("#solvebtn").bind("click", SolveIt);

        for (var i = 0; i < gamedata["Answers"].length; i++) {

            $("<div/>", {
                'id': gamedata['Answers'][i].id,
                'class': 'ClsDrag' + " " + cls_drag
            }).appendTo('#drag_items');

            $("<div/>", {
                'id': 'optionsTxtQ' + gamedata['Answers'][i].id,
                'class': 'optionsTxtQ'
            }).appendTo('#' + gamedata['Answers'][i].id);

            $("<div/>", {
                'id': 'optionsValQ' + gamedata['Answers'][i].id,
                'class': 'optionsVal',
                'html': gamedata['Answers'][i].text,
            }).appendTo('#optionsTxtQ' + gamedata['Answers'][i].id);

        }

        var strings = gamedata['Questions'];

        // Iterate over the array and split strings

        for (var i = 0; i < strings.length; i++) {
            if (strings[i].startsWith("blank_")) {
                fillblank++;
                $("<div/>", {
                    'id': strings[i],
                    'num': i,
                    'class': 'ClsDrop'
                }).appendTo('#drop_items');

                $("#" + strings[i]).bind("click", function () {
                    if ($(this).text().trim() === '') {

                    } else {
                        $(this).html("");
                        var tempid = $(this).attr("num");
                        $("#" + tempid).show();
                        $(this).attr("num", "");
                    }
                });

            } else {
                $("<div/>", {
                    'class': 'ClsText',
                    'html': strings[i]
                }).appendTo('#drop_items');

            }
        }

        // for draggable
        $(".ClsDrag").draggable({
            revert: function (p_bDropped) {
                if (!p_bDropped) {
                    // console.log("revert the div");
                    var DragID = $(this).attr("id");
                    $("#" + DragID).removeAttr("style");
                    $("#" + DragID).css("z-index", 0).css("position", "relative");
                } else {

                    if (p_bDropped.text().trim() === '') {
                        // console.log('The span is empty.');
                        playclick();
                        var DragID = $(this).attr("id");
                        p_bDropped.attr("num", DragID);
                        p_bDropped.html($("#" + DragID).find(".optionsVal").html());
                        $("#" + DragID).removeAttr("style");
                        $("#" + DragID).css("z-index", 0).css("position", "relative").css("display", "none");
                    } else {

                        var DragID = $(this).attr("id");
                        $("#" + DragID).removeAttr("style");
                        $("#" + DragID).css("z-index", 0).css("position", "relative");
                    }

                }
            },
            create: function (event, ui) {

            },
            start: function (e, ui) {
                var DragID = e.target.id;
                $("#" + DragID).css("z-index", 1);
            },
            drag: function (e, ui) {
                wrapperRulerLeft = $("#wrapper").offset().left;
                var changeLeft = ui.position.left;
                var newLeft = changeLeft / DragDropScale.x;
                var changeTop = ui.position.top;
                var newTop = changeTop / DragDropScale.y;
                ui.position.left = newLeft;
                ui.position.top = newTop;

                $('body').mouseleave(function () {
                    $('body').mouseup();
                });

            },
            stop: function (e, ui) {

            }
        });

        // for droppable
        $(".ClsDrop").droppable({
            /*tolerance: "pointer",*/
            activate: function (event, ui) {
                //console.log("droppable activate");
            },
            deactivate: function (event, ui) {
                //console.log("droppable deactivate");
            },
            out: function (event, ui) {
                //console.log("droppable out");

            },
            over: function (event, ui) {
                //console.log("droppable over" + $(this).attr('id'));
            },
            drop: function (e, ui) {
                // console.log("droppable drop");
            }
        });

        $(function () {
            var parent = $("#drag_items");
            var divs = parent.children();
            while (divs.length) {
                parent.append(divs.splice(Math.floor(Math.random() * divs.length), 1)[0]);
            }
        });

        updatemainUI();
    }//end addElements function
		
		//to solve the game 
		var SolveIt = function() {
			AutoSolved=true;
			const NoBlanks = $(".ClsDrop").length;
			for(let i = 0; i < NoBlanks; i++){
				
				const $dragElm = $("#a"+(i+1) );
				const $dragElmTxt= $("#optionsValQa"+(i+1)).text()
				const $dropElm = $("#blank_a" +(i+1) );
				
				$dragElm.css("z-index","1")
				
				// Calculate the position difference
				const diffX = $dropElm.offset().left - $dragElm.offset().left;
				const diffY = $dropElm.offset().top - $dragElm.offset().top;

				// Animate the movement
				$dragElm.animate({
					left: `+=${diffX}px`,
					top: `+=${diffY}px` 
				}, 800, function() {
					// Animation complete, hide the element
					score++;
					$dragElm.hide();
					$dropElm.html($dragElmTxt);
					$dropElm.css("background-color","rgb(76 175 80 / 45%)")
				});
				
			}
			
		}

    // check ques and ans result function
    function checkresult() {
		if(!AutoSolved){
			$(".ClsDrop").each(function (index) {
            if ($(this).attr("id").substring(6) == $(this).attr("num")) {
                // console.log("true")
                score++;
                $(this).css("background-color", 'rgb(76 175 80 / 45%)');
            } else {
                $(this).css("background-color", 'red');
            }
        });
		}
        

        setTimeout(function () {
            showresult();
        }, 2500);

    }

    // show result screen function
    function showresult() {
		const NoBlanks = $(".ClsDrop").length;
        clearInterval(myInterval);
        var scorepercentage = (score * 100) / fillblank;
        scorepercentage = scorepercentage.toFixed(2).replace(/[.,]00$/, '');

        $("#bad_feedbackImg").hide()
        $("#good_feedbackImg").hide();
        $("#vediocontainer_result").hide();
        $("#myVideo_result")[0].pause();

        if (scorepercentage >= game_ui["game_screen"]["resultpage"].minumum) {

            var filePath = game_ui["game_screen"]["resultpage"].goodeffect;
            var extension = filePath.split('.').pop().toLowerCase();
            if (extension === "mp4") {

                $("#vediocontainer_result").show();
                $("#myVideo_result source").attr("src", filePath);
                $("#myVideo_result")[0].load();
                $("#myVideo_result")[0].play();

            } else if (extension === "jpg" || extension === "jpeg" || extension === "png" || extension === "gif") {
                objPlaywelldoneMusic.src = game_ui["game_screen"]["resultpage"].goodaudio;
                playwelldone();
                $("#good_feedbackImg").show();
                $("#good_feedbackImg").css("background-image", 'url(' + filePath + ')');
            } else {
                // console.log("File is neither an MP4 video nor an image");
            }

        } else {

            var filePath = game_ui["game_screen"]["resultpage"].badeffect;
            var extension = filePath.split('.').pop().toLowerCase();
            if (extension === "mp4") {
                $("#vediocontainer_result").show();
                $("#myVideo_result source").attr("src", filePath);
                $("#myVideo_result")[0].load();
                $("#myVideo_result")[0].play();
            } else if (extension === "jpg" || extension === "jpeg" || extension === "png" || extension === "gif") {
                objPlaywelldoneMusic.src = game_ui["game_screen"]["resultpage"].badaudio;
                playwelldone();
                $("#bad_feedbackImg").show();
                $("#bad_feedbackImg").css("background-image", 'url(' + filePath + ')');
            } else {
                // console.log("File is neither an MP4 video nor an image");
            }
        }



        $("#scoreval").html(score + "/" + NoBlanks);
        $("#scorevalper").html(scorepercentage + '%');

        if (game_ui["game_screen"]["settimer"].count == "none") {

        }
        $("#welldonebg").show();
        $(".welldone").removeClass('animated zoomIn');
        $(".welldone").addClass('animated zoomIn');

    }

    // replay game function
    function replay() {
        playclick();
        score = 0;
        fillblank = 0;
        $("#timer").text("00:" + "00");
        timerval = game_ui["game_screen"]["settimer"].timeval;
        livesctr = 0;
        curQCtr = 0;
        for (var i = 0; i < game_ui["game_screen"]["lives"].number; i++) {
            $("#lives" + i).show();
        }
        addTimer();
        optionlnght = 0;
        $("#welldonebg").hide();
        $("#timeupbg").hide();
        $('#options_container').html("").empty();
        if (game_ui["game_screen"]["randomQuestions"].randomval == true) {
            shuffleArray(gamedata["Questions"]);
        }
        addElements();
    }

    // update UI for main elm
    function updatemainUI() {
        //  update UI for submit button
        const submitElm = document.getElementById('submitbtn');
        submitElm.style.width = game_ui["game_screen"]["submitUI"].width;
        submitElm.style.height = game_ui["game_screen"]["submitUI"].height;
        submitElm.style.left = game_ui["game_screen"]["submitUI"].left;
        submitElm.style.top = game_ui["game_screen"]["submitUI"].top;
        submitElm.style.borderRadius = game_ui["game_screen"]["submitUI"].borderRadius;
        submitElm.style.backgroundImage = 'url(' + game_ui["game_screen"]["submitUI"].backgroundImage + ')';
        submitElm.style.backgroundColor = game_ui["game_screen"]["submitUI"].backgroundColor;
        submitElm.style.border = game_ui["game_screen"]["submitUI"].border;

        //  update UI for submit button text
        const submittextElm = document.getElementById('submit_text');
        submittextElm.textContent = game_ui["game_screen"]["submitUI"].titleText
        submittextElm.style.fontSize = game_ui["game_screen"]["submitUI"].fontSize;
        submittextElm.style.color = game_ui["game_screen"]["submitUI"].color;
        submittextElm.style.textAlign = game_ui["game_screen"]["submitUI"].textalign;
        submittextElm.style.fontWeight = game_ui["game_screen"]["submitUI"].fontweight;

        //  update UI for submit button text
        const drop_itemsElm = document.getElementById('drop_items');
        drop_itemsElm.style.fontSize = game_ui["game_screen"]["sentenceBlankUI"].fontSize;
        drop_itemsElm.style.color = game_ui["game_screen"]["sentenceBlankUI"].color;
		drop_itemsElm.style.fontWeight = game_ui["game_screen"]["sentenceBlankUI"].fontWeight;
		drop_itemsElm.style.backgroundColor = game_ui["game_screen"]["sentenceBlankUI"].backgroundColor;

    }

    // create and add bgm audio
    var objPlayPauseMusic = document.createElement("audio");
    objPlayPauseMusic.src = bgmsrc;
    objPlayPauseMusic.addEventListener('ended', playbgm);
    $("#play_audio").bind("click", playbgm);
    $("#pause_audio").bind("click", pausemusic);

    // play bgm audio function
    function playbgm() {

        if (objPlayPauseMusic.paused) {
            objPlayPauseMusic.play();
        } else {
            objPlayPauseMusic.pause();
        }

    }

    // pause bgm audio function
    function pausemusic() {
        if (playmusicflag == true) {
            playmusicflag = false;
        } else {
            playmusicflag = true;
        }
    }

    // create and add click audio
    var objPlayClickMusic = document.createElement("audio");
    objPlayClickMusic.src = "Assets/Data/audio/click.wav";

    // play click audio function
    function playclick() {
        if (playmusicflag == true) {
            objPlayClickMusic.play();
        }
    }

    // create and add welldone audio
    var objPlaywelldoneMusic = document.createElement("audio");
    objPlaywelldoneMusic.src = "Assets/Data/audio/welldone.wav";

    // play welldone audio function
    function playwelldone() {
        if (playmusicflag == true) {
            objPlaywelldoneMusic.play();
        }

    }

    // create and add wrong audio
    var objPlaytryagainMusic = document.createElement("audio");
    objPlaytryagainMusic.src = "Assets/Data/audio/wrong.wav";

    // play wrong audio function
    function playtryagain() {
        if (playmusicflag == true) {
            objPlaytryagainMusic.play();
        }

    }

});
